program TestModuleLoader;

    Uses LoaderIntf, SysUtils;

	Procedure Init (var e: PLoaderError);
	Begin
	    New(e);
        If e = Nil Then exit;
    
        New(e^.msg);
        e^.msg^ := '';

        New(e^.par0);
        e^.par0^ := '';

        New(e^.par1);
        e^.par1^ := '';
    End;

	Procedure ReportError (e: PLoaderError);
	Begin
        writeln(Format('===Error #%d: %s', [e^.n, e^.msg^]));
		writeln('par0=',e^.par0^);
		writeln('par1=',e^.par1^)
	End;
	
Var
    modname, proc: PChar;
    err: PLoaderError;
Begin
    modname := 'TestExeModule'; proc := 'main';
    writeln('Running "' + proc +  '" from module "' + modname + '"');

    Init (err);
    If err = Nil Then halt(1);

    InitLoaderError(err);
    Run(modname, proc, 1, NIL);

    If err^.n <> 0 Then
        ReportError(err)
End.
